﻿using Syncfusion.ListView.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Xamarin.Forms;

namespace Swiping
{
    public class ListViewSwipingViewModel
    {
        #region Fields

        private ObservableCollection<ListViewInboxInfo> inboxInfo;
        private SfListView sfList;
       
 
        #endregion

        #region Constructor

        public ListViewSwipingViewModel()
        {
            GenerateSource();
        }

        #endregion

        #region Properties

        public ObservableCollection<ListViewInboxInfo> InboxInfo
        {
            get { return inboxInfo; }
            set { this.inboxInfo = value; }
        }
        public SfListView SfList
        {
            get { return sfList; }
            set { this.sfList = value; }
        }
        public ICommand SetFavorites
        {
            get;
            set;
        }
        public ICommand Delete
        {
            get;
            set;
        }
        public ICommand ResetAllEntry
        {
            get;
            set;
        }
        #endregion

        #region Generate Source

        private void GenerateSource()
        {
            ListViewInboxInfoRepository inboxinfo = new ListViewInboxInfoRepository();
            SetFavorites = new Command(Button1Tapped);
            Delete = new Command(Button2Tapped);
            ResetAllEntry = new Command(ResetButtonClicked);
            inboxInfo = inboxinfo.GetInboxInfo();
        }

        private void ResetButtonClicked(object obj)
        {
            foreach (var item in this.InboxInfo)
            {
                item.Title = "UnKnown";
                item.Subject = "UnKnown";
            }
            SfList.ResetSwipe();
        }

        private void Button2Tapped(object obj)
        {
            var itemData = obj as ListViewInboxInfo;
            itemData.Title = "UnKnown";
            itemData.Subject = "UnKnown";
            SfList.ResetSwipe();
        }

        private void Button1Tapped(object obj)
        {
            var itemData = obj as ListViewInboxInfo;
            itemData.Title = "UnKnown";
            itemData.Subject = "UnKnown";
            SfList.ResetSwipe();
        }

        #endregion
    }
}
